# Operators

## Base operators (@since 1.0.0)

### Roll

`XdY (INT, INT) -> INT[]`
- roll X dice with bounds [1, Y]

### Addition

`X+Y (INT, INT) -> INT`
- sum X and Y

`X+Y (INT[], INT) -> INT[]`
- appends Y to X

`X+=Y (INT, INT) -> INT`
- sum X and Y

`X+=Y (INT[], INT) -> INT[]`
- add Y to every element of X

### Subtraction

`X-Y (INT, INT) -> INT`
- subtract Y from X

`X-Y (INT[], INT) -> INT[]`
- appends -Y to X

`X-=Y (INT, INT) -> INT`
- subtract Y from X

`X-=Y (INT[], INT) -> INT[]`
- subtracts Y from every element of X

### Multiplicaion

`X*Y (INT, INT) -> INT`
- multiply X and Y

`X*Y (INT[], INT) -> INT[]`
- multiply every element of X by Y

### Division (round)

`X/Y (INT, INT) -> INT`  
- divide X by Y, round

`X/Y (INT[], INT) -> INT[]`
- divide every element of X by Y, round

### Division (floor)

`X//Y (INT, INT) -> INT`
- divide X by Y, floor

`X//Y (INT[], INT) -> INT[]`
- divide every element of X by Y, floor

### Max

`X^Y (INT, INT) -> INT`
- return highest of X and Y

`X^Y (INT[], INT) -> INT[]`
- return Y highest INTs from X

### Min

`X_Y (INT, INT) -> INT`
- returns lowest of X and Y

`X_Y (INT[], INT) -> INT[]`
- return Y lowest INTs from X

### Sum

`[X] INT -> INT`
- identity

`[X] INT[] -> INT`
- sums elements of array

### Drop

`X-L INT[] -> INT[]`
- drop lowest INT from X

`X-H INT[] -> INT[]`
- drop highest INT from X

## Future

- Explosive rolls (XdY!)
- Compounding rolls (XdY!!)

# Data Types

- Integer
- Integer[] (dynamic)

# Precedence ordering

1) `()`, `[]`
2) `XdY`
3) `-L`, `-H`
4) `^`, `_`
5) `*`, `/`, `//`,
6) `+`, `-`, `+=`, `-=`
